import java.util.Random;
import java.util.ArrayList;
/**
 * Methodenbox für Kapitel 1.8, Einstiegsaufgabe
 * 
 * @author Franz Jetzinger
 * @version 1.0
 */
public class Methodenbox
{
    Random zufall = new Random();
    Walze walze1;
    Walze walze2;
    Walze walze3;
    Text Text; 
    Text play;
    /**
     * Konstruktor für Objekte der Klasse AlgoWrapper
     */
    public Methodenbox()
    {
        walze1 = new Walze();
        walze1.setzePosition(100,100);
        walze2 = new Walze();
        walze2.setzePosition(150,100);
        walze3 = new Walze();
        walze3.setzePosition(200,100);
        Text = new Text();
        Text.TextGrößeSetzen(25);
        Text.PositionSetzen(100,50);
        Text.TextSetzen("Guthaben: 5");
        play = new Text();
        play.TextGrößeSetzen(20);
        play.TextSetzen("Rufe die Methode play auf!");
        play.PositionSetzen(100, 200);
    }

    
    void schreibeGuthaben(int Guthaben)
    {
        Text.TextSetzen("Guthaben: " + Guthaben);
    }

    void warte(int Millisekunden)
    {
        try {
            Thread.sleep(Millisekunden);
        } catch (InterruptedException e) {
            System.out.println("Thread is interrupted");
        }
    }

    void dreheWalzen()
    {
        walze1.drehe();
        walze1.setzePosition(100,100);
        walze2.drehe();
        walze2.setzePosition(150,100);
        walze3.drehe();
        walze3.setzePosition(200,100);
    }

    void schreibeNichtGenügendGuthaben()
    {
        Text.TextSetzen("Nicht genügend Guthaben!");
    }

    String Walze1GibFigur()
    {
        return  walze1.gibFigur();
    }

    String Walze2GibFigur()
    {
        return  walze2.gibFigur();
    }

    String Walze3GibFigur()
    {
        return  walze3.gibFigur();
    }

    private class Walze
    {
        WalzenFiguren Figuren;
        WalzenFigur aktuelleFigur;

        Walze()
        {
            Figuren = new WalzenFiguren();
            aktuelleFigur = Figuren.gibZufälligeFigur();
            aktuelleFigur.setzeSichtbarkeit(true);
        }

        void drehe()
        {
            aktuelleFigur.setzeSichtbarkeit(false);
            aktuelleFigur = Figuren.gibZufälligeFigur();
            aktuelleFigur.SichtbarkeitSetzen(true);
        }

        String gibFigur()
        {
            return aktuelleFigur.gibFigur();
        }

        void setzePosition(int x, int y)
        {
            aktuelleFigur.PositionSetzen(x,y);
        }
    }

    private class WalzenFiguren
    {
        ArrayList<WalzenFigur> Figuren;

        WalzenFiguren()
        {
            Figuren = new ArrayList<WalzenFigur>();
            WalzenFigur figur1 = new Figur1();
            figur1.SichtbarkeitSetzen(false);
            Figuren.add(figur1);
            WalzenFigur figur2 = new Figur2();
            figur2.SichtbarkeitSetzen(false);
            Figuren.add(figur2);
            WalzenFigur figur3 = new Figur3();
            figur3.SichtbarkeitSetzen(false);
            Figuren.add(figur3);
            WalzenFigur figur4 = new Figur4();
            figur4.SichtbarkeitSetzen(false);
            Figuren.add(figur4);
            WalzenFigur figur5 = new Figur5();
            figur5.SichtbarkeitSetzen(false);
            Figuren.add(figur5);
            WalzenFigur figur6 = new Figur6();
            figur6.SichtbarkeitSetzen(false);
            Figuren.add(figur6);
            WalzenFigur kreuz = new Kreuz();
            kreuz.SichtbarkeitSetzen(false);
            Figuren.add(kreuz);           
        }

        WalzenFigur gibZufälligeFigur()
        {
            return Figuren.get(zufall.nextInt(7));
        }
    }

    private abstract class WalzenFigur extends Figur
    {
        String Figur;

        String gibFigur()
        {
            return Figur;
        }

        void setzeSichtbarkeit(boolean Sichtbarkeit)
        {
            SichtbarkeitSetzen(Sichtbarkeit);
        }
    }

    private class Figur1 extends WalzenFigur
    {
        Figur1()
        {
            super();
            Figur = "Figur1";
            FigurteilFestlegenRechteck(0,0, 30, 30,"blau");
        }

    }
    private class Figur2 extends WalzenFigur
    {
        Figur2()
        {
            super();
            Figur = "Figur2";
            FigurteilFestlegenRechteck(0,0, 30, 30,"gelb");
        }
    }
    private class Figur3 extends WalzenFigur
    {
        Figur3()
        {
            super();
            Figur = "Figur3";
            FigurteilFestlegenEllipse(0,0, 30, 30, "blau");
        }
    }
    private class Figur4 extends WalzenFigur
    {
        Figur4()
        {
            super();
            Figur = "Figur4";
            FigurteilFestlegenEllipse(0,0, 30, 30, "gelb");
        }
    }
    private class Figur5 extends WalzenFigur
    {
        Figur5()
        {
            super();
            Figur = "Figur5";
            FigurteilFestlegenDreieck(15,0,30,30,0,30, "blau");
        }
    }
    private class Figur6 extends WalzenFigur
    {
        Figur6()
        {
            super();
            Figur = "Figur6";
            FigurteilFestlegenDreieck(15,0,30,30,0,30, "gelb");
        }
    }
    private class Kreuz extends WalzenFigur
    {
        Kreuz()
        {
            super();
            Figur = "Kreuz";
            FigurteilFestlegenRechteck(22, 0, 5, 50, "rot");
            FigurteilFestlegenRechteck(0, 22, 50, 5, "rot");
        }
    }

}
